package com.zcloud.service.emergency.impl;

import com.zcloud.entity.Page;
import com.zcloud.entity.PageData;
import com.zcloud.mapper.datasource.emergency.EmergencyDrillBasicMapper;
import com.zcloud.service.emergency.*;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

/**
 * 说明：应急方案基本信息
 * 作者：luoxiaobao
 * 时间：2021-06-19
 * 官网：www.zcloudchina.com
 */
@Service
@Transactional //开启事物
public class EmergencyDrillBasicServiceImpl implements EmergencyDrillBasicService{

	@Autowired
	private EmergencyDrillBasicMapper emergencydrillbasicMapper;
	@Autowired
	private EmergencyDrillOrgService emergencyDrillOrgService;
	@Autowired
	private EmergencyDrillOrgMemberService emergencyDrillOrgMemberService;
	@Autowired
	private EmergencyDrillContentService emergencyDrillContentService;
	@Autowired
	private EmergencyDrillSceneService emergencyDrillSceneService;
	@Autowired
	private EmergencyDrillReportService emergencyDrillReportService;
	@Autowired
	private EmergencyDrillAttachmentService emergencyDrillAttachmentService;

	/**新增
	 * @param pd
	 * @throws Exception
	 */
	public void save(PageData pd)throws Exception{
		emergencydrillbasicMapper.save(pd);
	}

	/**删除
	 * @param pd
	 * @throws Exception
	 */
	public void delete(PageData pd)throws Exception{
		emergencydrillbasicMapper.delete(pd);
		String ArrayDATA_IDS[] = {pd.getString("EMERGENCYDRILLBASIC_ID")};
		pd.put("ArrayDATA_IDS", ArrayDATA_IDS);	//待删除ids
		emergencyDrillOrgService.deleteByBaseId(pd);
		emergencyDrillOrgMemberService.deleteByBaseId(pd);
		emergencyDrillContentService.deleteByBaseId(pd);
		emergencyDrillSceneService.deleteByBaseId(pd);
		emergencyDrillReportService.deleteByBaseId(pd);
		emergencyDrillAttachmentService.deleteByBaseId(pd);
	}

	/**修改
	 * @param pd
	 * @throws Exception
	 */
	public void edit(PageData pd)throws Exception{
		emergencydrillbasicMapper.edit(pd);
	}

	/**列表
	 * @param page
	 * @throws Exception
	 */
	public List<PageData> list(Page page)throws Exception{
		return emergencydrillbasicMapper.datalistPage(page);
	}

	/**列表(全部)
	 * @param pd
	 * @throws Exception
	 */
	public List<PageData> listAll(PageData pd)throws Exception{
		return emergencydrillbasicMapper.listAll(pd);
	}

	/**通过id获取数据
	 * @param pd
	 * @throws Exception
	 */
	public PageData findById(PageData pd)throws Exception{
		return emergencydrillbasicMapper.findById(pd);
	}

	/**批量删除
	 * @param pd
	 * @throws Exception
	 */
	public void deleteAll(PageData pd)throws Exception{
		emergencydrillbasicMapper.deleteAll(pd);
		emergencyDrillOrgService.deleteByBaseId(pd);
		emergencyDrillOrgMemberService.deleteByBaseId(pd);
		emergencyDrillContentService.deleteByBaseId(pd);
		emergencyDrillSceneService.deleteByBaseId(pd);
		emergencyDrillReportService.deleteByBaseId(pd);
		emergencyDrillAttachmentService.deleteByBaseId(pd);
	}

}

